diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #include "ns3/boolean.h"
@@ -23,12 +12,14 @@
 #include "ns3/mobility-helper.h"
 #include "ns3/multi-model-spectrum-channel.h"
 #include "ns3/nist-error-rate-model.h"
+#include "ns3/non-communicating-net-device.h"
 #include "ns3/ofdm-ppdu.h"
 #include "ns3/pointer.h"
 #include "ns3/spectrum-wifi-helper.h"
 #include "ns3/spectrum-wifi-phy.h"
 #include "ns3/string.h"
 #include "ns3/test.h"
+#include "ns3/waveform-generator.h"
 #include "ns3/wifi-mac-header.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy-listener.h"
@@ -48,9 +39,8 @@
 NS_LOG_COMPONENT_DEFINE("SpectrumWifiPhyTest");
 
 static const uint8_t CHANNEL_NUMBER = 36;
-static const uint16_t CHANNEL_WIDTH = 20; // MHz
-static const uint16_t GUARD_WIDTH =
-    CHANNEL_WIDTH; // MHz (expanded to channel width to model spectrum mask)
+static const MHz_u CHANNEL_WIDTH = 20;
+static const MHz_u GUARD_WIDTH = CHANNEL_WIDTH; // expanded to channel width to model spectrum mask
 
 /**
  * Extended SpectrumWifiPhy class for the purpose of the tests.
@@ -91,6 +81,25 @@
             return rxing.second;
         });
     }
+
+    /**
+     * Indicate whether a given band is tracked by the interference helper
+     *
+     * \param startStopFreqs the start and stop frequencies per segment of the band
+     *
+     * \return true if the specified band is tracked by the interference helper, false otherwise
+     */
+    bool IsBandTracked(const std::vector<WifiSpectrumBandFrequencies>& startStopFreqs) const
+    {
+        for (const auto& [band, nis] : m_niChanges)
+        {
+            if (band.frequencies == startStopFreqs)
+            {
+                return true;
+            }
+        }
+        return false;
+    }
 };
 
 NS_OBJECT_ENSURE_REGISTERED(ExtInterferenceHelper);
@@ -119,17 +128,17 @@
     Ptr<SpectrumWifiPhy> m_phy; ///< Phy
     /**
      * Make signal function
-     * \param txPowerWatts the transmit power in watts
+     * \param txPower the transmit power
      * \param channel the operating channel of the PHY used for the transmission
      * \returns Ptr<SpectrumSignalParameters>
      */
-    Ptr<SpectrumSignalParameters> MakeSignal(double txPowerWatts,
+    Ptr<SpectrumSignalParameters> MakeSignal(Watt_u txPower,
                                              const WifiPhyOperatingChannel& channel);
     /**
      * Send signal function
-     * \param txPowerWatts the transmit power in watts
+     * \param txPower the transmit power
      */
-    void SendSignal(double txPowerWatts);
+    void SendSignal(Watt_u txPower);
     /**
      * Spectrum wifi receive success function
      * \param psdu the PSDU
@@ -168,35 +177,36 @@
 
 // Make a Wi-Fi signal to inject directly to the StartRx() method
 Ptr<SpectrumSignalParameters>
-SpectrumWifiPhyBasicTest::MakeSignal(double txPowerWatts, const WifiPhyOperatingChannel& channel)
+SpectrumWifiPhyBasicTest::MakeSignal(Watt_u txPower, const WifiPhyOperatingChannel& channel)
 {
-    WifiTxVector txVector = WifiTxVector(OfdmPhy::GetOfdmRate6Mbps(),
-                                         0,
-                                         WIFI_PREAMBLE_LONG,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         CHANNEL_WIDTH,
-                                         false);
+    WifiTxVector txVector{OfdmPhy::GetOfdmRate6Mbps(),
+                          0,
+                          WIFI_PREAMBLE_LONG,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          CHANNEL_WIDTH,
+                          false};
 
-    Ptr<Packet> pkt = Create<Packet>(1000);
+    auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
 
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
 
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
-    Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
+    const auto txDuration =
+        m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
 
-    Ptr<WifiPpdu> ppdu = Create<OfdmPpdu>(psdu, txVector, channel, m_uid++);
+    auto ppdu = Create<OfdmPpdu>(psdu, txVector, channel, m_uid++);
 
-    Ptr<SpectrumValue> txPowerSpectrum = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(
+    auto txPowerSpectrum = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(
         channel.GetPrimaryChannelCenterFrequency(CHANNEL_WIDTH),
         CHANNEL_WIDTH,
-        txPowerWatts,
+        txPower,
         GUARD_WIDTH);
-    Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
+    auto txParams = Create<WifiSpectrumSignalParameters>();
     txParams->psd = txPowerSpectrum;
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
@@ -207,9 +217,9 @@
 
 // Make a Wi-Fi signal to inject directly to the StartRx() method
 void
-SpectrumWifiPhyBasicTest::SendSignal(double txPowerWatts)
+SpectrumWifiPhyBasicTest::SendSignal(Watt_u txPower)
 {
-    m_phy->StartRx(MakeSignal(txPowerWatts, m_phy->GetOperatingChannel()), nullptr);
+    m_phy->StartRx(MakeSignal(txPower, m_phy->GetOperatingChannel()), nullptr);
 }
 
 void
@@ -238,13 +248,13 @@
 void
 SpectrumWifiPhyBasicTest::DoSetup()
 {
-    Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
-    Ptr<Node> node = CreateObject<Node>();
-    Ptr<WifiNetDevice> dev = CreateObject<WifiNetDevice>();
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto node = CreateObject<Node>();
+    auto dev = CreateObject<WifiNetDevice>();
     m_phy = CreateObject<SpectrumWifiPhy>();
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
+    auto interferenceHelper = CreateObject<InterferenceHelper>();
     m_phy->SetInterferenceHelper(interferenceHelper);
-    Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
+    auto error = CreateObject<NistErrorRateModel>();
     m_phy->SetErrorRateModel(error);
     m_phy->SetDevice(dev);
     m_phy->AddChannel(spectrumChannel);
@@ -269,21 +279,21 @@
 void
 SpectrumWifiPhyBasicTest::DoRun()
 {
-    double txPowerWatts = 0.010;
+    Watt_u txPower{0.01};
     // Send packets spaced 1 second apart; all should be received
-    Simulator::Schedule(Seconds(1), &SpectrumWifiPhyBasicTest::SendSignal, this, txPowerWatts);
-    Simulator::Schedule(Seconds(2), &SpectrumWifiPhyBasicTest::SendSignal, this, txPowerWatts);
-    Simulator::Schedule(Seconds(3), &SpectrumWifiPhyBasicTest::SendSignal, this, txPowerWatts);
+    Simulator::Schedule(Seconds(1), &SpectrumWifiPhyBasicTest::SendSignal, this, txPower);
+    Simulator::Schedule(Seconds(2), &SpectrumWifiPhyBasicTest::SendSignal, this, txPower);
+    Simulator::Schedule(Seconds(3), &SpectrumWifiPhyBasicTest::SendSignal, this, txPower);
     // Send packets spaced 1 microsecond second apart; none should be received (PHY header reception
     // failure)
     Simulator::Schedule(MicroSeconds(4000000),
                         &SpectrumWifiPhyBasicTest::SendSignal,
                         this,
-                        txPowerWatts);
+                        txPower);
     Simulator::Schedule(MicroSeconds(4000001),
                         &SpectrumWifiPhyBasicTest::SendSignal,
                         this,
-                        txPowerWatts);
+                        txPower);
     Simulator::Run();
     Simulator::Destroy();
 
@@ -323,9 +333,9 @@
         ++m_notifyRxEndError;
     }
 
-    void NotifyTxStart(Time duration, double txPowerDbm) override
+    void NotifyTxStart(Time duration, dBm_u txPower) override
     {
-        NS_LOG_FUNCTION(this << duration << txPowerDbm);
+        NS_LOG_FUNCTION(this << duration << txPower);
     }
 
     void NotifyCcaBusyStart(Time duration,
@@ -382,8 +392,8 @@
     uint32_t m_notifyRxEndOk{0};           ///< notify receive end OK
     uint32_t m_notifyRxEndError{0};        ///< notify receive end error
     uint32_t m_notifyMaybeCcaBusyStart{0}; ///< notify maybe CCA busy start
-    Time m_ccaBusyStart{0};                ///< CCA_BUSY start time
-    Time m_ccaBusyEnd{0};                  ///< CCA_BUSY end time
+    Time m_ccaBusyStart{};                 ///< CCA_BUSY start time
+    Time m_ccaBusyEnd{};                   ///< CCA_BUSY end time
 };
 
 /**
@@ -396,7 +406,6 @@
 {
   public:
     SpectrumWifiPhyListenerTest();
-    ~SpectrumWifiPhyListenerTest() override;
 
   private:
     void DoSetup() override;
@@ -409,10 +418,6 @@
 {
 }
 
-SpectrumWifiPhyListenerTest::~SpectrumWifiPhyListenerTest()
-{
-}
-
 void
 SpectrumWifiPhyListenerTest::DoSetup()
 {
@@ -424,8 +429,8 @@
 void
 SpectrumWifiPhyListenerTest::DoRun()
 {
-    double txPowerWatts = 0.010;
-    Simulator::Schedule(Seconds(1), &SpectrumWifiPhyListenerTest::SendSignal, this, txPowerWatts);
+    Watt_u txPower{0.01};
+    Simulator::Schedule(Seconds(1), &SpectrumWifiPhyListenerTest::SendSignal, this, txPower);
     Simulator::Run();
 
     NS_TEST_ASSERT_MSG_EQ(m_count, 1, "Didn't receive right number of packets");
@@ -484,10 +489,8 @@
     Ptr<ExtSpectrumWifiPhy> m_txPhy; ///< TX PHY
     Ptr<ExtSpectrumWifiPhy> m_rxPhy; ///< RX PHY
 
-    uint16_t m_txChannelWidth; ///< TX channel width (MHz)
-    uint16_t m_rxChannelWidth; ///< RX channel width (MHz)
-
-    std::set<WifiSpectrumBandIndices> m_ruBands; ///< spectrum bands associated to all the RUs
+    MHz_u m_txChannelWidth; ///< TX channel width
+    MHz_u m_rxChannelWidth; ///< RX channel width
 };
 
 SpectrumWifiPhyFilterTest::SpectrumWifiPhyFilterTest()
@@ -505,23 +508,23 @@
 void
 SpectrumWifiPhyFilterTest::SendPpdu()
 {
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_SU,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         m_txChannelWidth,
-                                         false,
-                                         false);
-    Ptr<Packet> pkt = Create<Packet>(1000);
+    WifiTxVector txVector{HePhy::GetHeMcs0(),
+                          0,
+                          WIFI_PREAMBLE_HE_SU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          m_txChannelWidth,
+                          false,
+                          false};
+    auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
     hdr.SetAddr1(Mac48Address("00:00:00:00:00:01"));
     hdr.SetSequenceNumber(1);
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
     m_txPhy->Send(WifiConstPsduMap({std::make_pair(SU_STA_ID, psdu)}), txVector);
 }
 
@@ -534,24 +537,29 @@
 void
 SpectrumWifiPhyFilterTest::RxCallback(Ptr<const Packet> p, RxPowerWattPerChannelBand rxPowersW)
 {
-    for (const auto& pair : rxPowersW)
+    for (const auto& [band, powerW] : rxPowersW)
     {
-        NS_LOG_INFO("band: (" << pair.first << ") -> powerW=" << pair.second << " ("
-                              << WToDbm(pair.second) << " dBm)");
+        NS_LOG_INFO(
+            "band: (" << band << ") -> powerW=" << powerW
+                      << (powerW > 0.0 ? " (" + std::to_string(WToDbm(powerW)) + " dBm)" : ""));
     }
 
     size_t numBands = rxPowersW.size();
-    size_t expectedNumBands = std::max(1, (m_rxChannelWidth / 20));
+    auto expectedNumBands = std::max<std::size_t>(1, m_rxChannelWidth / 20);
     expectedNumBands += (m_rxChannelWidth / 40);
     expectedNumBands += (m_rxChannelWidth / 80);
     expectedNumBands += (m_rxChannelWidth / 160);
-    expectedNumBands += m_ruBands.size();
+    expectedNumBands += m_rxPhy
+                            ->GetHeRuBands(m_rxPhy->GetCurrentInterface(),
+                                           m_rxPhy->GetGuardBandwidth(
+                                               m_rxPhy->GetCurrentInterface()->GetChannelWidth()))
+                            .size();
 
     NS_TEST_ASSERT_MSG_EQ(numBands,
                           expectedNumBands,
                           "Total number of bands handled by the receiver is incorrect");
 
-    uint16_t channelWidth = std::min(m_txChannelWidth, m_rxChannelWidth);
+    MHz_u channelWidth = std::min(m_txChannelWidth, m_rxChannelWidth);
     auto band = m_rxPhy->GetBand(channelWidth, 0);
     auto it = rxPowersW.find(band);
     NS_LOG_INFO("powerW total band: " << it->second << " (" << WToDbm(it->second) << " dBm)");
@@ -579,8 +587,9 @@
         it = rxPowersW.find(band);
         NS_LOG_INFO("powerW in primary 20 MHz channel: " << it->second << " (" << WToDbm(it->second)
                                                          << " dBm)");
-        int rxPowerPrimaryChannel20 = static_cast<int>(WToDbm(it->second) + 0.5);
-        int expectedRxPowerPrimaryChannel20 = 16 - static_cast<int>(RatioToDb(channelWidth / 20));
+        const auto rxPowerPrimaryChannel20 = static_cast<int>(WToDbm(it->second) + 0.5);
+        const auto expectedRxPowerPrimaryChannel20 =
+            16 - static_cast<int>(RatioToDb(channelWidth / 20));
         NS_TEST_ASSERT_MSG_EQ(rxPowerPrimaryChannel20,
                               expectedRxPowerPrimaryChannel20,
                               "Received power in the primary 20 MHz band is not correct");
@@ -593,40 +602,39 @@
     // WifiHelper::EnableLogComponents();
     // LogComponentEnable("SpectrumWifiPhyTest", LOG_LEVEL_ALL);
 
-    Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
-    Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel>();
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto lossModel = CreateObject<FriisPropagationLossModel>();
     lossModel->SetFrequency(5.180e9);
     spectrumChannel->AddPropagationLossModel(lossModel);
-    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
-        CreateObject<ConstantSpeedPropagationDelayModel>();
+    auto delayModel = CreateObject<ConstantSpeedPropagationDelayModel>();
     spectrumChannel->SetPropagationDelayModel(delayModel);
 
-    Ptr<Node> txNode = CreateObject<Node>();
-    Ptr<WifiNetDevice> txDev = CreateObject<WifiNetDevice>();
+    auto txNode = CreateObject<Node>();
+    auto txDev = CreateObject<WifiNetDevice>();
     m_txPhy = CreateObject<ExtSpectrumWifiPhy>();
-    Ptr<InterferenceHelper> txInterferenceHelper = CreateObject<InterferenceHelper>();
+    auto txInterferenceHelper = CreateObject<InterferenceHelper>();
     m_txPhy->SetInterferenceHelper(txInterferenceHelper);
-    Ptr<ErrorRateModel> txErrorModel = CreateObject<NistErrorRateModel>();
+    auto txErrorModel = CreateObject<NistErrorRateModel>();
     m_txPhy->SetErrorRateModel(txErrorModel);
     m_txPhy->SetDevice(txDev);
     m_txPhy->AddChannel(spectrumChannel);
     m_txPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    Ptr<ConstantPositionMobilityModel> apMobility = CreateObject<ConstantPositionMobilityModel>();
+    auto apMobility = CreateObject<ConstantPositionMobilityModel>();
     m_txPhy->SetMobility(apMobility);
     txDev->SetPhy(m_txPhy);
     txNode->AggregateObject(apMobility);
     txNode->AddDevice(txDev);
 
-    Ptr<Node> rxNode = CreateObject<Node>();
-    Ptr<WifiNetDevice> rxDev = CreateObject<WifiNetDevice>();
+    auto rxNode = CreateObject<Node>();
+    auto rxDev = CreateObject<WifiNetDevice>();
     m_rxPhy = CreateObject<ExtSpectrumWifiPhy>();
-    Ptr<InterferenceHelper> rxInterferenceHelper = CreateObject<InterferenceHelper>();
+    auto rxInterferenceHelper = CreateObject<InterferenceHelper>();
     m_rxPhy->SetInterferenceHelper(rxInterferenceHelper);
-    Ptr<ErrorRateModel> rxErrorModel = CreateObject<NistErrorRateModel>();
+    auto rxErrorModel = CreateObject<NistErrorRateModel>();
     m_rxPhy->SetErrorRateModel(rxErrorModel);
     m_rxPhy->AddChannel(spectrumChannel);
     m_rxPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    Ptr<ConstantPositionMobilityModel> sta1Mobility = CreateObject<ConstantPositionMobilityModel>();
+    auto sta1Mobility = CreateObject<ConstantPositionMobilityModel>();
     m_rxPhy->SetMobility(sta1Mobility);
     rxDev->SetPhy(m_rxPhy);
     rxNode->AggregateObject(sta1Mobility);
@@ -647,8 +655,8 @@
 void
 SpectrumWifiPhyFilterTest::RunOne()
 {
-    uint16_t txFrequency;
-    switch (m_txChannelWidth)
+    MHz_u txFrequency;
+    switch (static_cast<uint16_t>(m_txChannelWidth))
     {
     case 20:
     default:
@@ -664,16 +672,17 @@
         txFrequency = 5250;
         break;
     }
-    auto txChannelNum = std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                                        txFrequency,
-                                                                        m_txChannelWidth,
-                                                                        WIFI_STANDARD_80211ax,
-                                                                        WIFI_PHY_BAND_5GHZ));
+    auto txChannelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                           txFrequency,
+                                                           m_txChannelWidth,
+                                                           WIFI_STANDARD_80211ax,
+                                                           WIFI_PHY_BAND_5GHZ)
+                            ->number;
     m_txPhy->SetOperatingChannel(
         WifiPhy::ChannelTuple{txChannelNum, m_txChannelWidth, WIFI_PHY_BAND_5GHZ, 0});
 
-    uint16_t rxFrequency;
-    switch (m_rxChannelWidth)
+    MHz_u rxFrequency;
+    switch (static_cast<uint16_t>(m_rxChannelWidth))
     {
     case 20:
     default:
@@ -689,41 +698,15 @@
         rxFrequency = 5250;
         break;
     }
-    auto rxChannelNum = std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                                        rxFrequency,
-                                                                        m_rxChannelWidth,
-                                                                        WIFI_STANDARD_80211ax,
-                                                                        WIFI_PHY_BAND_5GHZ));
+    auto rxChannelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                           rxFrequency,
+                                                           m_rxChannelWidth,
+                                                           WIFI_STANDARD_80211ax,
+                                                           WIFI_PHY_BAND_5GHZ)
+                            ->number;
     m_rxPhy->SetOperatingChannel(
         WifiPhy::ChannelTuple{rxChannelNum, m_rxChannelWidth, WIFI_PHY_BAND_5GHZ, 0});
 
-    m_ruBands.clear();
-    for (uint16_t bw = 160; bw >= 20; bw = bw / 2)
-    {
-        for (uint16_t i = 0; i < (m_rxChannelWidth / bw); ++i)
-        {
-            for (unsigned int type = 0; type < 7; type++)
-            {
-                auto ruType = static_cast<HeRu::RuType>(type);
-                for (std::size_t index = 1; index <= HeRu::GetNRus(bw, ruType); index++)
-                {
-                    HeRu::SubcarrierGroup subcarrierGroup =
-                        HeRu::GetSubcarrierGroup(bw, ruType, index);
-                    HeRu::SubcarrierRange subcarrierRange =
-                        std::make_pair(subcarrierGroup.front().first,
-                                       subcarrierGroup.back().second);
-                    const auto band =
-                        HePhy::ConvertHeRuSubcarriers(bw,
-                                                      m_rxPhy->GetGuardBandwidth(m_rxChannelWidth),
-                                                      m_rxPhy->GetSubcarrierSpacing(),
-                                                      subcarrierRange,
-                                                      i);
-                    m_ruBands.insert(band);
-                }
-            }
-        }
-    }
-
     Simulator::Schedule(Seconds(1), &SpectrumWifiPhyFilterTest::SendPpdu, this);
 
     Simulator::Run();
